@import "../global.scss";
@import "../custom-variables";

@mixin mat-custom-button-theme($theme) {
  $accent: map-get($theme, accent);
  $primary: map-get($theme, primary);
  $warn: map-get($theme, warn);
  $caution: map-get($theme, caution);
  $success: map-get($theme, success);
  $highlight: map-get($theme, highlight);
  $background: map-get($theme, background);
  $foreground: map-get($theme, foreground);

  $btn-shadow: 0 0.0625rem 0.125rem mat-color($primary, 300);
  $primary-gradient: linear-gradient(45deg, $blue-gradient1 0%, $blue-gradient2 100%);

  /** Buttons Based **/
  .mat-button,
  .mat-raised-button,
  .mat-flat-button,
  .mat-stroked-button {
    border-radius: 0.25rem;
    font-weight: 600;
    font-size: 0.8125rem;
    outline: 0;
    padding: 0.25rem 0.5rem;
    line-height: 1.5rem;
    height: 2rem;
    text-transform: none;
    min-width: auto;
    box-shadow: $btn-shadow;
    display: flex;
    align-items: center;
    text-decoration: none;
    color: $grey-9;

    .mat-button-wrapper {
      display: flex;
      align-items: center;
      justify-content: space-between;
      flex: 1;
    }

    mat-icon + span {
      margin-left: 0.5rem;
    }
    span + mat-icon {
      margin-left: 0.5rem;
    }
    mat-icon:only-child:not(.mat-icon-button) {
      margin: 0 -4px;
    }

    &[small] {
      padding: 0.5rem;
      font-size: 0.75rem;
      line-height: 0.8125rem;
      height: 1.5rem;

      mat-icon {
        width: 1rem;
        height: 1rem;
      }
    }

    &[large] {
      padding: 0.5rem 0.75rem;
      font-size: 1rem;
      line-height: 1.5rem;
      height: 2.5rem;

      mat-icon {
        width: 1.625rem;
        height: 1.625rem;
      }
    }

    &[extra-large] {
      padding: 0.5rem 0.75rem;
      font-weight: 700;
      font-size: 0.875rem;
      line-height: 1.5rem;
      height: 3.5rem;

      mat-icon {
        width: 1.625rem;
        height: 1.625rem;
        margin: 0 -0.75rem;
      }
    }
  }

  .mat-button-base {
    &.mat-button-disabled {
      box-shadow: none;
      opacity: 0.5;
      user-select: none;
    }
    &:focus:enabled {
      box-shadow: 0 0 0 0.125rem mat-color($primary, 200);
      border-color: transparent;
    }
  }

  /* Icon color for RAISED and FLAT buttons */
  .mat-raised-button,
  .mat-flat-button {
    &.mat-primary {
      mat-icon {
        color: $white;
      }
      span + mat-icon {
        color: $white;
      }
    }
    &.mat-accent {
      mat-icon {
        color: $grey-7;
      }
      span + mat-icon {
        color: $grey-5;
      }
    }
    &.mat-warn {
      mat-icon {
        color: $white;
      }
      span + mat-icon {
        color: $white;
      }
    }
  }

  /* Icon color for DEFAULT and STROKED buttons */
  .mat-stroked-button {
    // mat-icon {
    //   color: $grey-7;
    // }
    // span + mat-icon {
    //   color: $grey-5;
    // }
  }

  /** Buttons **/
  .mat-button {
    box-shadow: none;
    background-color: inherit;

    &.mat-primary {
      @include button-color($primary);
    }

    &.mat-accent {
      &:hover:enabled {
        background-color: mat-color($accent, 200);
      }

      &:active:enabled {
        background-color: mat-color($accent, 200);
      }
    }

    &.mat-warn {
      @include button-color($warn);
    }

    &.mat-caution {
      @include button-color($caution);
    }

    &.mat-success {
      @include button-color($success);
    }

    &.mat-button-disabled {
      .mat-icon {
        color: mat-color($accent, 500);
      }
    }
  }

  /** Buttons Raised **/
  .mat-raised-button {
    box-shadow: 0 0.0625rem 0.125rem rgba(35, 67, 97, 0.25), 0 0.125rem 0.5rem rgba(35, 67, 97, 0.19);

    &:not(.mat-button-disabled):active:not([class*="mat-elevation-z"]) {
      box-shadow: none;
    }
    &.mat-button-disabled {
      box-shadow: none;
    }

    &.mat-primary {
      transition: none;
      background-image: $primary-gradient;
      border-color: mat-color($primary, 900);

      &:hover:not(.mat-button-disabled) {
        background-image: none;
        background-color: mat-color($primary, 900);
      }

      &:active:enabled {
        background-image: none;
        background-color: mat-color($primary, 700);
      }

      &.mat-button-disabled {
        color: $white;
      }
    }

    &.mat-accent {
      color: mat-color($accent, 900);
      background: $white;
      border: 0.0625rem solid mat-color($accent, 400);

      mat-icon:only-child {
        margin: 0 -5px;
      }

      &:hover:enabled {
        background-color: mat-color($accent, 200);
      }

      &.mat-button-disabled {
        background: mat-color($accent, 200);
        border-color: mat-color($accent, 200);
        color: mat-color($accent, 800);
      }
    }

    &.mat-warn {
      @include raised-button-color($warn);
    }

    &.mat-caution {
      @include raised-button-color($caution);
    }

    &.mat-success {
      @include raised-button-color($success);
    }

    &.mat-highlight {
      @include raised-button-color($highlight);
    }
  }

  /** Buttons Stroked **/
  .mat-stroked-button {
    &.mat-button-disabled {
      border-color: mat-color($accent, 400);
      color: mat-color($accent, 800);
    }

    &.mat-primary {
      @include stroke-button-color($primary);
    }

    &.mat-accent {
      color: mat-color($accent, 900);
      border-color: mat-color($accent, 400);

      &:hover:enabled {
        background-color: mat-color($accent, 200);
      }

      &:focus:enabled {
        border-color: mat-color($accent, 300);
      }

      &:active:enabled {
        box-shadow: none;
        background-color: mat-color($primary, 100);
        border-color: #c5d6fb;
      }
      &.mat-button-disabled {
        color: mat-color($accent, 800);
      }

      span + mat-icon {
        color: mat-color($accent, 500);
      }
    }

    &.mat-warn {
      @include stroke-button-color($warn);
    }

    &.mat-caution {
      @include stroke-button-color($caution);
    }

    &.mat-success {
      @include stroke-button-color($success);
    }

    &.mat-highlight {
      @include stroke-button-color($highlight);
    }
  }

  /** Buttons Flat **/
  .mat-flat-button {
    &.mat-button-disabled.mat-button-disabled {
      color: mat-contrast($accent, 500);
    }

    &.mat-primary {
      &.mat-button-disabled {
        color: mat-contrast($primary, 700);
        background-color: mat-color($primary, 700);
      }
    }

    &.mat-accent {
      background: mat-color($accent, 200);
      &.mat-button-disabled {
        color: mat-contrast($accent, 500);
        background: transparent;
      }
    }

    &.mat-warn {
      @include flat-button-color($warn);
    }

    &.mat-caution {
      @include flat-button-color($caution);
    }

    &.mat-success {
      @include flat-button-color($success);
    }

    &.mat-highlight {
      @include flat-button-color($highlight);
    }
  }

  /** Buttons Icons **/
  .mat-icon-button {
    &[small] {
      line-height: 0.8125rem;
      height: 1.5rem;
      width: 1.5rem;

      mat-icon {
        width: 1.5rem;
        height: 1.5rem;

        svg {
          width: calc(100% - 0.25rem);
          height: calc(100% - 0.25rem);
          margin-top: 0.125rem;
        }
      }
    }

    &[large] {
      height: 3.5rem;
      width: 3.5rem;

      mat-icon {
        width: 2.5rem;
        height: 2.5rem;

        svg {
          width: calc(100% - 0.5rem);
          height: calc(100% - 0.5rem);
          margin-top: 0.25rem;
        }
      }
    }

    &.mat-primary {
      color: $white;
      background-color: mat-color($primary, 500);
      border-color: mat-color($primary, 500);

      &:hover:not(.mat-button-disabled) {
        background-color: mat-color($primary, 800);
      }

      mat-icon {
        color: mat-contrast($primary, 700);
      }
    }

    &.mat-accent {
      color: mat-color($accent, 900);
      background-color: $white;
      border-color: mat-color($accent, 400);

      &:hover:enabled {
        background-color: mat-color($accent, 200);
      }

      &.mat-button-disabled {
        background: mat-color($accent, 200);
        .mat-button-wrapper {
          color: mat-color($accent, 800);
        }
      }
    }

    &.mat-warn {
      color: $white;
      background-color: mat-color($warn, 500);
      border-color: mat-color($warn, 500);

      &:hover:enabled {
        background-color: mat-color($warn, 800);
      }

      mat-icon {
        color: mat-contrast($warn, 500);
      }
    }
  }
}

@mixin button-color($color) {
  &:active:enabled {
    background-color: mat-color($color, 100);
  }
}

@mixin stroke-button-color($color) {
  color: mat-color($color, 900);
  border-color: mat-color($color, 300);

  &:hover:enabled {
    background-color: mat-color($color, 50);
    border-color: mat-color($color, 700);
  }

  &:focus:enabled {
    border-color: mat-color($color, 300);
  }

  &:active:enabled {
    box-shadow: none;
    background-color: mat-color($color, 200);
  }
  &.mat-button-disabled {
    color: mat-color($color, 800);
  }

  span + mat-icon {
    color: mat-color($color, 500);
  }
}

@mixin raised-button-color($color) {
  background-color: mat-color($color, 900);

  &:hover:enabled:not(.mat-button-disabled) {
    background-color: mat-color($color, 700);
  }

  &.mat-button-disabled {
    color: mat-contrast($color, 600);
    background-color: mat-color($color, 600);
  }
}

@mixin flat-button-color($color) {
  &.mat-button-disabled {
    color: mat-contrast($color, 500);
    background-color: mat-color($color, 500);
  }
}
